
Redmine - Defect #4257

Broken support for Principal plugins

2009-11-20 12:15 - Alexey Palazhchenko

Status: New Start date: 2009-11-20

Priority: High Due date:  

Assignee:  % Done: 0%

Category: Plugin API Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version:  

Description

I'm not sure when exactly it happens (it's worked sometime ago), but things becomes broken for Principal with empty plugin.

How to reproduce:

$ cat vendor/plugins/test_plugin/init.rb

require 'redmine'

require 'dispatcher'

Dispatcher.to_prepare :test_plugin do

  require_dependency 'principal'

end

Redmine::Plugin.register :test_plugin do

end

(no other files in vendor/test_plugin)

$ rake test:units

<...>

1) Failure:

test_roles_updated(GroupTest) [/test/unit/group_test.rb:57]:

<[1, 2]> expected but was

<[1]>.

2) Failure:

test_visible_scope_for_user(IssueTest) [/test/unit/issue_test.rb:94]:

<false> is not true.

478 tests, 2036 assertions, 2 failures, 0 errors

Related issues:

Related to Redmine - Defect #5434: Redmine 0.9.3 - HTTP500 when trying to fil... Closed 2010-05-04

History

#1 - 2009-12-07 12:47 - Alexey Palazhchenko

Any ideas? Please help, it's showstoper for me.

#2 - 2009-12-09 11:49 - Alexey Palazhchenko

- Assignee changed from Eric Davis to Jean-Philippe Lang

Jean-Philippe, any ideas?

#3 - 2009-12-10 17:09 - Alexey Palazhchenko

Ok, second failure was bisect down to r3039. No idea about first yet...

#4 - 2009-12-15 01:52 - Eric Davis

Aleksey:

That's really odd.  I have a few plugins that work with Users that are still working.  Is this failing in just a test plugin or something you are working on?
#5 - 2009-12-15 06:00 - Alexey Palazhchenko

Eric, I'm working on plugin for some Redmine models. When I found this 2 broken tests, I started to remove code from my plugin – and it's ended with

this bare skeleton.

#6 - 2010-10-17 22:07 - Jean-Baptiste Barth

- Assignee deleted (Jean-Philippe Lang)

Had the same kind of problem recently with memberships. It seems Rails has some troubles reloading things correctly when some classes has been

reloaded through engines. It may have something to do with STI (doesn't affect other classes from what I've seen).

For instance, with your test plugin, in test/unit/group_test.rb, line 57: 

assert_equal [1, 2], user.reload.roles_for_project(project).collect(&:id).sort

#=> KO

assert_equal [1, 2], User.find(9).roles_for_project(project).collect(&:id).sort

#=> OK

 I tried to mark some classes as unloadable in the core, doesn't change anything...

#7 - 2010-10-23 13:44 - Jean-Baptiste Barth

- Status changed from New to 7

- Assignee set to Jean-Baptiste Barth

I continue to think it's a rails bug, but it's solved by forcing memberships reload in User model : 

  def reload(*args)

    @name = nil

    self.memberships.reload

    super(*args)

  end

 Any thought about integrating that into the core ? (note it also works when monkey patching User class this way in the plugin...)

#8 - 2010-10-23 14:03 - Alexey Palazhchenko

Any thought about integrating that into the core ?

 I'm for it, with a big FIXME comment.

Is it a know Rails bug?

#9 - 2010-10-23 18:48 - Jean-Baptiste Barth

Alexey Palazhchenko wrote:

Is it a know Rails bug?

 Didn't find it on lighthouse. It seems inherited scopes (in our case User#like) are also lost when reloading...

#10 - 2012-06-10 22:42 - Jean-Baptiste Barth

- Assignee deleted (Jean-Baptiste Barth)

#11 - 2013-01-13 21:04 - Jean-Philippe Lang

- Status changed from 7 to New

Assigned issue with no assignee back to New status.
